/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace RhodesProcessorLib
{
    /*! Custom content BodyInfo */
    public abstract class BodyInfo
    {
        public enum BodyType
        {
            Rectangle = 0,
            Circle = 1
        }

        private BodyType _type;

        public BodyInfo(BodyType type) { _type = type; }

        public BodyType Type { get { return _type; } set { _type = value; } }
    }
    /*! Custom content RectangleBodyInfo */
    public class RectangleBodyInfo : BodyInfo
    {
        private float _width;
        private float _height;

        public RectangleBodyInfo() : base(BodyInfo.BodyType.Rectangle) 
        {
            _width = 30;
            _height = 30;
        }

        public RectangleBodyInfo(float width, float height) : base(BodyInfo.BodyType.Rectangle)
        {
            _width = width;
            _height = height;
        }

        public float Width { get { return _width; } set { _width = value; } }
        public float Height { get { return _height; } set { _height = value; } }
    }

    /*! Custom content CircleBodyInfo */
    public class CircleBodyInfo : BodyInfo
    {
        private float _radius;

        public CircleBodyInfo() : base(BodyInfo.BodyType.Circle) { }
        public CircleBodyInfo(float radius) : base(BodyInfo.BodyType.Circle)
        {
            _radius = radius;
        }

        public float Radius { get { return _radius; } set { _radius = value; } }
    }
}
