/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for CircleBodyInfo */
    class CircleBodyInfoReader : ContentTypeReader<CircleBodyInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override CircleBodyInfo Read(ContentReader input, CircleBodyInfo existingInstance)
        {
            CircleBodyInfo bodyInfo = new CircleBodyInfo();

            bodyInfo.Type = input.ReadObject<BodyInfo.BodyType>();
            bodyInfo.Radius = input.ReadSingle();

            return bodyInfo;
        }
    }
}
