/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for CircleCollisionInfo */
    [ContentTypeWriter]
    class CircleCollisionInfoWriter : ContentTypeWriter<CircleCollisionInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, CircleCollisionInfo value)
        {
            output.WriteObject(value.Type);
            output.Write(value.Offset);
            output.Write(value.RotationOffset);
            output.Write(value.Radius);
            output.Write(value.Edges);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.CircleCollisionInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.CircleCollisionInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
