/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for CompoundEntity */
    [ContentTypeWriter]
    class CompundEntityWriter : ContentTypeWriter<CompoundEntityCompiled>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, CompoundEntityCompiled value)
        {
            output.Write(value.Name);
            output.Write(value.Active);
            output.WriteObject(value.Entities);
            output.WriteObject(value.RevoluteJoints);
            output.WriteObject(value.AngleJoints);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "rhodes.engine.CompoundEntity, rhodes, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "rhodes.engine.CompoundEntityReader, rhodes, Version=1.0.0.0, Culture=neutral";
        }

    }
}
