/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for EmitterInfo */
    class EmitterInfoReader : ContentTypeReader<EmitterInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override EmitterInfo Read(ContentReader input, EmitterInfo existingInstance)
        {
            EmitterInfo ret = new EmitterInfo();

            ret.Spritemap = input.ReadString();
            ret.BlendEffect = input.ReadObject<SpriteBlendMode>();
            ret.Positions = input.ReadObject<List<Vector2>>();

			ret.MinVel = input.ReadVector2();
			ret.MaxVel = input.ReadVector2();

            ret.EmitLifetime = input.ReadSingle();
            ret.ParticlePersSec = input.ReadInt32();
            ret.ParticleAmount = input.ReadInt16();
            ret.ParticleLifetime = input.ReadSingle();
            ret.ParticleLifeRandomizer = input.ReadSingle();

            ret.MinStartSpeed = input.ReadSingle();
            ret.MaxStartSpeed = input.ReadSingle();
            ret.MinEndSpeed = input.ReadSingle();
            ret.MaxEndSpeed = input.ReadSingle();

            ret.StartRotationRange = input.ReadSingle();

            ret.MinStartRotSpeed = input.ReadSingle();
            ret.MaxStartRotSpeed = input.ReadSingle();
            ret.MinEndRotSpeed = input.ReadSingle();
            ret.MaxEndRotSpeed = input.ReadSingle();

            ret.MinStartSize = input.ReadVector2();
            ret.MaxStartSize = input.ReadVector2();
            ret.MinEndSize = input.ReadVector2();
            ret.MaxEndSize = input.ReadVector2();

            ret.MinStartColor = input.ReadVector4();
            ret.MaxStartColor = input.ReadVector4();
            ret.MinEndColor = input.ReadVector4();
            ret.MaxEndColor = input.ReadVector4(); 

            return ret;
        }
    }
}
