/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for Particle */
    [ContentTypeWriter]
    class ParticleWriter : ContentTypeWriter<ParticleCompiled>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, ParticleCompiled value)
        {
            output.WriteObject(value.EmitterInfoList);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "rhodes.graphics.particles.ParticleEngine, rhodes, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "rhodes.graphics.particles.ParticleReader, rhodes, Version=1.0.0.0, Culture=neutral";
        }
    }
}
