/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content reader for PolygonCollisionInfo */
    class PolygonCollisionInfoReader : ContentTypeReader<PolygonCollisionInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override PolygonCollisionInfo Read(ContentReader input, PolygonCollisionInfo existingInstance)
        {
            PolygonCollisionInfo collisionInfo = new PolygonCollisionInfo();

            collisionInfo.Type = input.ReadObject<CollisionInfo.CollisionType>();
            collisionInfo.CollisionGridCellSize = input.ReadSingle();
            collisionInfo.Offset = input.ReadVector2();
            collisionInfo.RotationOffset = input.ReadSingle();
            collisionInfo.Vertices = input.ReadObject<List<Vector2>>();

            return collisionInfo;
        }
    }
}
