/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for PolygonCollisionInfo */
    [ContentTypeWriter]
    class PolygonCollisionInfoWriter : ContentTypeWriter<PolygonCollisionInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, PolygonCollisionInfo value)
        {
            output.WriteObject(value.Type);
            output.Write(value.CollisionGridCellSize);
            output.Write(value.Offset);
            output.Write(value.RotationOffset);
            output.WriteObject<List<Vector2>>(value.Vertices);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.PolygonCollisionInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.PolygonCollisionInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
