/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for RectangleBodyInfo */
    [ContentTypeWriter]
    class RectangleBodyInfoWriter : ContentTypeWriter<RectangleBodyInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, RectangleBodyInfo value)
        {
            output.WriteObject(value.Type);
            output.Write(value.Width);
            output.Write(value.Height);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RectangleBodyInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RectangleBodyInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
