/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace RhodesProcessorLib
{
    /*! Custom content reader for RevoluteJointInfo */
    class RevoluteJointInfoReader : ContentTypeReader<RevoluteJointInfo>
    {
        /*! \copydoc ContentTypeReader::Read */
        protected override RevoluteJointInfo Read(ContentReader input, RevoluteJointInfo existingInstance)
        {
            RevoluteJointInfo jointInfo = new RevoluteJointInfo();

            jointInfo.Entity1 = input.ReadString();
            jointInfo.Entity2 = input.ReadString();
            jointInfo.Offset = input.ReadVector2();
            jointInfo.BiasFactor = input.ReadSingle();
            jointInfo.Softness = input.ReadSingle();

            return jointInfo;
        }
    }
}
