/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for RevoluteJointInfo */
    [ContentTypeWriter]
    class RevoluteJointInfoWriter : ContentTypeWriter<RevoluteJointInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, RevoluteJointInfo value)
        {
            output.Write(value.Entity1);
            output.Write(value.Entity2);
            output.Write(value.Offset);
            output.Write(value.BiasFactor);
            output.Write(value.Softness);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RevoluteJointInfoReader, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "RhodesProcessorLib.RevoluteJointInfo, RhodesProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
