/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace RhodesProcessorLib
{
    /*! Custom content compiled for SimpleEntity */
    class SimpleEntityCompiled
    {
        //! general
        private String _name;
        private Vector2 _position;
        private float _rotation;
        private Boolean _active;

        //! sprite
        private String _spriteMap;
        private Boolean _cycle;
        private String _animation;

        //! body
        private float _mass;
        private float _momentofinertia;
        private Boolean _ignoreGravity;
        private BodyInfo _bodyInfo;
        private Boolean _isStatic;

        //! geom
        private Boolean _collisionEnabled;
        private Enums.CollisionCategories _collisionCategory;
        private Enums.CollisionCategories _collidesWith;
        private Boolean _collisionResponseEnabled;
        private List<CollisionInfo> _collisionList;
        private CollisionInfo _collisionInfo;
        private float _frictionCoefficient;
        
        public SimpleEntityCompiled()
        {
            _position = new Vector2();
            _bodyInfo = new RectangleBodyInfo();
            _collisionList = new List<CollisionInfo>();
        }

        public String Name { get { return _name; } set { _name = value; } }
        public Vector2 Position { get { return _position; } set { _position = value; } }
        public float Rotation { get { return _rotation; } set { _rotation = value; } }
        public Boolean Active { get { return _active; } set { _active = value; } }

        public String SpriteMap { get { return _spriteMap; } set { _spriteMap = value; } }
        public Boolean Cycle { get { return _cycle; } set { _cycle = value; } }
        public String Animation { get { return _animation; } set { _animation = value; } }
        
        public float Mass { get { return _mass; } set { _mass = value; } }
        public float MomentOfInertia { get { return _momentofinertia; } set { _momentofinertia = value; } }
        public Boolean IgnoreGravity { get { return _ignoreGravity; } set { _ignoreGravity = value; } }
        public Boolean IsStatic { get { return _isStatic; } set { _isStatic = value; } }
        public BodyInfo BodyInfo { get { return _bodyInfo; } set { _bodyInfo = value; } }

        public Boolean CollisionEnabled { get { return _collisionEnabled; } set { _collisionEnabled = value; } }
        public Enums.CollisionCategories CollisionCategory { get { return _collisionCategory; } set { _collisionCategory = value; } }
        public Enums.CollisionCategories CollidesWith { get { return _collidesWith; } set { _collidesWith = value; } }
        public Boolean CollisionResponseEnabled { get { return _collisionResponseEnabled; } set { _collisionResponseEnabled = value; } }
        public float FrictionCoefficient { get { return _frictionCoefficient; } set { _frictionCoefficient = value; } }
        public List<CollisionInfo> CollisionList { get { return _collisionList; } set { _collisionList = value; } }
        public CollisionInfo CollisionInfo { get { return _collisionInfo; } set { _collisionInfo = value; } }
    }
}
