/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace RhodesProcessorLib
{
    /*! Custom content writer for SimpleEntity */
    [ContentTypeWriter]
    class SimpleEntityWriter: ContentTypeWriter<SimpleEntityCompiled> 
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, SimpleEntityCompiled value)
        {
            output.Write(value.Name);
            output.WriteObject(value.Position);
            output.Write(value.Rotation);
            output.Write(value.Active);
            
            output.Write(value.SpriteMap);
            output.Write(value.Cycle);
            output.Write(value.Animation);

            output.Write(value.Mass);
            output.Write(value.MomentOfInertia);
            output.Write(value.IgnoreGravity);
            output.Write(value.IsStatic);
            output.WriteObject(value.BodyInfo);
            
            output.Write(value.CollisionEnabled);
            output.WriteObject(value.CollisionCategory);
            output.WriteObject(value.CollidesWith);
            output.Write(value.CollisionResponseEnabled);
            output.Write(value.FrictionCoefficient);

            output.WriteObject(value.CollisionList);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "rhodes.engine.SimpleEntity, rhodes, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "rhodes.engine.SimpleEntityReader, rhodes, Version=1.0.0.0, Culture=neutral";
        }
    }
}
