using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;
using System.Xml;
using rhodes.graphics;

namespace SedohrProcessorLib
{
    [ContentProcessor]
    class CompoundObjectProcessor : ContentProcessor<CompoundObjectSource, CompoundObjectCompiled>
    {
        public override CompoundObjectCompiled Process(CompoundObjectSource input, ContentProcessorContext context)
        {
            CompoundObjectCompiled retVal = new CompoundObjectCompiled();
            XmlDocument xml = input.Xml;

            Dictionary<String, int> tension = new Dictionary<string, int>();
            Dictionary<String, int> health = new Dictionary<string, int>();

            foreach (XmlNode node in xml.GetElementsByTagName("general")[0].ChildNodes)
            {
                if (node.Name.Equals("name"))
                    retVal.Name = node.InnerText;
                if (node.Name.Equals("compound"))
                    retVal.Compound = node.InnerText;
                if (node.Name.Equals("jointAttrib"))
                {
                    String[] pair = node.InnerText.Split(',');
                    tension.Add(node.Attributes["entity"].InnerText, int.Parse(pair[0]));
                    health.Add(node.Attributes["entity"].InnerText, int.Parse(pair[1]));
                }
            }

            retVal.Tension = tension;
            retVal.Health = health;

            return retVal;
        }
    }
}
