using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
    [ContentTypeWriter]
    class CompoundObjectWriter : ContentTypeWriter<CompoundObjectCompiled>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, CompoundObjectCompiled value)
        {
            output.Write(value.Name);
            output.Write(value.Compound);
            output.WriteObject(value.Tension);
            output.WriteObject(value.Health);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "sedohr.objects.CompoundObject, sedohr, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "sedohr.objects.CompoundObjectReader, sedohr, Version=1.0.0.0, Culture=neutral";
        }
    }
}
