using System;
using System.Collections.Generic;
using System.Text;

using rhodes.graphics;

namespace SedohrProcessorLib
{
    public class LayerInfo
    {
        private int _depth;
        private float _proportion;
        private List<String> _statics;
        private List<String> _simpleObjects;
        private List<String> _compoundObejcts;
        private List<GraphicsInfo> _graphics;
        private List<LightInfo> _lightInfo;

        public LayerInfo()
        {
            _depth = 0;
            _proportion = 1.0f;
            _statics = new List<string>();
            _simpleObjects = new List<string>();
            _compoundObejcts = new List<string>();
            _graphics = new List<GraphicsInfo>();
            _lightInfo = new List<LightInfo>();
        }

        public int Depth { get { return _depth; } set { _depth = value; } }
        public float Proportion { get { return _proportion; } set { _proportion = value; } }
        public List<String> Statics { get { return _statics; } set { _statics = value; } }
        public List<String> SimpleObjects { get { return _simpleObjects; } set { _simpleObjects = value; } }
        public List<String> CompoundObjects { get { return _compoundObejcts; } set { _compoundObejcts = value; } }
        public List<GraphicsInfo> Graphics { get { return _graphics; } set { _graphics = value; } }
        public List<LightInfo> LightInfo { get { return _lightInfo; } set { _lightInfo = value; } }
    }
}
