/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
    /*! Custom content writer for CircleBodyInfo */
    [ContentTypeWriter]
    class LayerInfoWriter : ContentTypeWriter<LayerInfo>
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, LayerInfo value)
        {
            output.Write(value.Depth);
            output.Write(value.Proportion);
            output.WriteObject(value.Statics);
            output.WriteObject(value.SimpleObjects);
            output.WriteObject(value.CompoundObjects);
            output.WriteObject(value.Graphics);
            output.WriteObject(value.LightInfo);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.LayerInfoReader, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "SedohrProcessorLib.LayerInfo, SedohrProcessorLib, Version=1.0.0.0, Culture=neutral";
        }
    }
}
