using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
    [ContentTypeWriter]
    class LevelWriter : ContentTypeWriter<LevelCompiled> 
    {
        /*! \copydoc ContentTypeWriter::Write */
        protected override void Write(ContentWriter output, LevelCompiled value)
        {
            output.WriteObject(value.Layers);
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeType */
        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "sedohr.Level, sedohr, Version=1.0.0.0, Culture=neutral";
        }

        /*! \copydoc ContentTypeWriter::GetRuntimeReader */
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "sedohr.LevelReader, sedohr, Version=1.0.0.0, Culture=neutral";
        }
    }
}
