using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Graphics;

namespace SedohrProcessorLib
{
    /*! Custom content reader for LightInfo */
    class LightInfoReader : ContentTypeReader<LightInfo>
    {
        protected override LightInfo Read(ContentReader input, LightInfo existingInstance)
        {
            LightInfo light = new LightInfo();

            light.Position = input.ReadVector3();
            light.Attenuation = input.ReadVector3();
            light.Color = input.ReadVector4();
            light.IsAttenuated = input.ReadBoolean();

            return light;
        }
    }
}
