using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;
using System.Xml;
using rhodes.graphics;

namespace SedohrProcessorLib
{
	[ContentProcessor]
	class SimpleObjectProcessor : ContentProcessor<SimpleObjectSource, SimpleObjectCompiled>
	{
		public override SimpleObjectCompiled Process(SimpleObjectSource input, ContentProcessorContext context)
		{
			SimpleObjectCompiled retVal = new SimpleObjectCompiled();
			XmlDocument xml = input.Xml;

			foreach (XmlNode node in xml.GetElementsByTagName("general")[0].ChildNodes)
			{
				if (node.Name.Equals("name"))
					retVal.Name = node.InnerText;

				if (node.Name.Equals("entity"))
					retVal.Entity = node.InnerText;
			}

			return retVal;
		}
	}
}
