using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;

namespace SedohrProcessorLib
{
	[ContentTypeWriter]
	class SimpleObjectWriter : ContentTypeWriter<SimpleObjectCompiled>
	{
		/*! \copydoc ContentTypeWriter::Write */
		protected override void Write(ContentWriter output, SimpleObjectCompiled value)
		{
			output.Write(value.Name);
			output.Write(value.Entity);
		}

		/*! \copydoc ContentTypeWriter::GetRuntimeType */
		public override string GetRuntimeType(TargetPlatform targetPlatform)
		{
			return "sedohr.objects.SimpleObject, sedohr, Version=1.0.0.0, Culture=neutral";
		}

		/*! \copydoc ContentTypeWriter::GetRuntimeReader */
		public override string GetRuntimeReader(TargetPlatform targetPlatform)
		{
			return "sedohr.objects.SimpleObjectReader, sedohr, Version=1.0.0.0, Culture=neutral";
		}
	}
}
