using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace SpriteMapProcessorLib
{
    //! 
    /*!
      Write out to the .xnb.
     */
    [ContentTypeWriter]
    class SpriteMapWriter : ContentTypeWriter<SpriteMapCompiled>
    {
        protected override void Write(ContentWriter output, SpriteMapCompiled value)
        {
            output.Write(value.Diffuse);
            output.Write(value.Normal);
            output.Write(value.Width);
            output.Write(value.Height);
            output.Write(value.FrameCount);
            output.WriteObject(value.Frames);
            output.WriteObject(value.Animations);       
        }

        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return "rhodes.graphics.SpriteMap, rhodes, Version=1.0.0.0, Culture=neutral";
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "rhodes.graphics.SpriteMapReader, rhodes, Version=1.0.0.0, Culture=neutral";
        }
    }
}
