sampler normalSampler : register(s0);

float rotation;

float4 main(
	float4 color : COLOR0, 
	float2 uv0 : TEXCOORD0 ) : COLOR0
{
	float4 tex = tex2D(normalSampler, uv0);
    float3 normal = normalize((tex.xyz - 0.5)*2.0);
    
    float r = normal.r * cos(rotation) - normal.g * sin(rotation);
    float g = normal.r * sin(rotation) + normal.g * cos(rotation);
    
    float3 newNorm = float3(r,g,1) / 2  + 0.5;
    
    return float4(newNorm, tex.a);
}

technique normal
{
    pass P0
    {
        PixelShader = compile ps_2_0 main();
    }
}
