/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

using rhodes.graphics;
using rhodes.physics;

namespace rhodes.engine
{
    /*! Base class for entities in the engine */
    public abstract class Entity
    {
        protected String _name;
        protected Boolean _active;

        public Entity(String name) 
        {
            _name = name;
            _active = true;
        }

        /*! Abstract method for entity update 
         * \param elapsedTime The time elapsed since last tick in milliseconds. */
        public abstract void update(float elapsedTime);

        /*! Properties */
        public String Name { get { return _name; } set { _name = value; } }
    }
}
