/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace rhodes.graphics
{
    /*! Composite used to output certain parts of the chain */
    public class DebugComposite : Composite
    {
        Effect _effect;

        public DebugComposite() 
			: base("debug")
        {
            GraphicsCore graphicsCore = GraphicsCore.getSingleton;

            _renderMode = PassType.Pass;

            _outputTarget.Add("scene", new RenderTarget2D(graphicsCore.Graphics.GraphicsDevice,
                graphicsCore.Width, graphicsCore.Height, 1, SurfaceFormat.Color,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleType,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleQuality));

            _effect = EffectResourceManager.getSingleton.load("assets/shaders/genericPost");   
        }

        /*! \copydoc Composite::render */
        public override void render()
        {
            GraphicsDevice graphicsDevice = GraphicsCore.getSingleton.Graphics.GraphicsDevice;

            //graphicsDevice.SetRenderTarget(0, null);
            //graphicsDevice.Clear(Color.Black);
            //GraphicsCore.getSingleton.SpriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            //GraphicsCore.getSingleton.SpriteBatch.Draw(_inputTarget["scene"].GetTexture(), new Vector2(0, 0), Color.White);
            //GraphicsCore.getSingleton.SpriteBatch.End();

            // Shader parameters
            // Specify the textures that coincide with the shaders texture name
            //_effect.Parameters["colorTexture"].SetValue(_inputTarget["scene"].GetTexture());
            _effect.Parameters["colorTexture"].SetValue(_inputTarget["normalTexture"].GetTexture());
            //_effect.Parameters["colorTexture"].SetValue(_inputTarget["diffuseTexture"].GetTexture());

            // Change the rendertarget to "scene"
            graphicsDevice.SetRenderTarget(0, null);
            graphicsDevice.RenderState.CullMode = CullMode.None;
            graphicsDevice.VertexDeclaration = _declaration;

            _effect.Begin();
            for (int i = 0; i < _effect.CurrentTechnique.Passes.Count; i++)
            {
                EffectPass pass = _effect.CurrentTechnique.Passes[i];
                pass.Begin();
                graphicsDevice.DrawUserPrimitives<VertexPositionTexture>(PrimitiveType.TriangleStrip, _vertices, 0, 2);
                pass.End();
            }
            _effect.End();

            // Return target to the back buffer
            graphicsDevice.SetRenderTarget(0, null);
        }
    }
}