/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace rhodes.graphics
{
    /*! Composite that renders the gui */
    public class GuiComposite : Composite
    {
        Effect _effect;

        public GuiComposite() 
			: base("gui")
        {
            GraphicsCore graphicsCore = GraphicsCore.getSingleton;

            _renderMode = PassType.Pass;

            _intermedTarget.Add("gui", new RenderTarget2D(graphicsCore.Graphics.GraphicsDevice,
                graphicsCore.Width, graphicsCore.Height, 1, SurfaceFormat.Color,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleType,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleQuality));

            _outputTarget.Add("final", new RenderTarget2D(graphicsCore.Graphics.GraphicsDevice,
                graphicsCore.Width, graphicsCore.Height, 1, SurfaceFormat.Color,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleType,
                graphicsCore.Graphics.GraphicsDevice.PresentationParameters.MultiSampleQuality));

            _effect = EffectResourceManager.getSingleton.load("assets/shaders/genericPost");
        }

        public override void render()
        {
            GraphicsDevice graphicsDevice = GraphicsCore.getSingleton.Graphics.GraphicsDevice;

            graphicsDevice.SetRenderTarget(0, null);

            graphicsDevice.Clear(Color.TransparentBlack);
            GraphicsCore.getSingleton.SpriteBatch.Begin(
                SpriteBlendMode.AlphaBlend,
                SpriteSortMode.Immediate,
                SaveStateMode.None);

            // scene manager render diffuse
            //SpriteManager.getSingleton.renderAll(SpriteMap.DIFFUSE, null);
            GraphicsCore.getSingleton.SpriteBatch.Draw(_inputTarget["scene"].GetTexture(),
                new Rectangle(0, 0, _inputTarget["scene"].Width, _inputTarget["scene"].Height), Color.White);            

            GraphicsCore.getSingleton.SpriteBatch.End();

            GuiManager.getSingleton.render();
            
            graphicsDevice.SetRenderTarget(0, null);
        }
    }
}