/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;

namespace rhodes.graphics
{
    /*! Loads and manages spritemaps. Makes sure there's only one around at all ug. */
    public class SpriteResourceManager: ResourceManager<SpriteMap>
    {
        private static volatile SpriteResourceManager _instance;
        private static object _syncRoot = new Object();

        //! Constructor
        private SpriteResourceManager() {}

        /*! Returns singleton instance of the SpriteResourceManager */
        public static SpriteResourceManager getSingleton
        {
            get
            {
                if (_instance == null)
                {
                    lock (_syncRoot)
                    {
                        if (_instance == null)
                            _instance = new SpriteResourceManager();
                    }
                }

                return _instance;
            }
        }
    }
}
