/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace rhodes.graphics
{
    /*! Singleton. Loads and manages textures. Makes sure there's only one around at all ug. */
    class TextureResourceManager: ResourceManager<Texture2D>
    {
        private static volatile TextureResourceManager _instance;
        private static object _syncRoot = new Object();

        private TextureResourceManager() {}

        /*! Returns singleton instance of the TextureResourceManager */
        public static TextureResourceManager getSingleton
        {
            get
            {
                if (_instance == null)
                {
                    lock (_syncRoot)
                    {
                        if (_instance == null)
                            _instance = new TextureResourceManager();
                    }
                }

                return _instance;
            }
        }
    }
}
