/*
 *  Author: Brian Murphy
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace rhodes.graphics.particles
{
	/*! Particle structure for storing various information of particles */
	public struct Particle
	{
		public short maxFrame;
		public short currentFrame;
		public float lifetime;
		public float currentLife;
		public float rotation;
        public float startRotationSpeed;
		public float endRotationSpeed;
		public Vector2 size;
		public Vector2 startSize;
		public Vector2 endSize;
		public Vector2 position;
		public Vector2 startVelocity;
		public Vector2 endVelocity;
		public Vector4 color;
		public Vector4 startColor;
		public Vector4 endColor;

		/*! Returns if the particle is alive or not */
        public bool Alive { get { return currentLife < lifetime; } }
	}
}
