/*
 *  Author: David Huynh
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 */

using System;
using System.Collections.Generic;
using System.Text;

using FarseerGames.FarseerPhysics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

using rhodes.graphics;
using rhodes.physics;

namespace sedohr.objects
{
	/// <summary>
	/// Base Class for objects in the level
	/// </summary>
    abstract class Object
    {
        protected String _name;
        protected Boolean _active;

        public Object(String name)
        {
            _name = name;
            _active = true;
        }

        public abstract void update(float elapsedTime);
        public abstract bool collisionCallback(Geom geometry1, Geom geometry2, ContactList contactList);

        public String Name { get { return _name; } set { _name = value; } }
    }
}
